{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Query Abone Dialog Unit                                           }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Abonedlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, ComCtrls, ZonuClass, ExtCtrls,
  Hzbdialog, Dlghead, EnhListView, ExtListView, Menus;

type
  TAboneDialog = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    ComboBox1: TComboBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Edit1: TEdit;
    Button1: TButton;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    BitBtn5: TBitBtn;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Button2: TButton;
    SpinEdit3: TSpinEdit;
    Button3: TButton;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Button4: TButton;
    Button5: TButton;
    ComboBox6: TComboBox;
    Button6: TButton;
    Button7: TButton;
    ComboBox7: TComboBox;
    Timer1: TTimer;
    Bevel1: TBevel;
    Bevel2: TBevel;
    HeaderFrame1: THeaderFrame;
    StatusBar1: TStatusBar;
    ListView1: TdfsExtListView;
    ListView2: TdfsExtListView;
    PopupMenu1: TPopupMenu;
    AllCheck: TMenuItem;
    AllUncheck: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ListView1ItemChecked(Sender: TObject; ItemIndex: Integer;
      Checked: Boolean);
    procedure AllCheckClick(Sender: TObject);
  private
    { Private 錾 }
    FResList: TResList;
    FAbonedEvt: TZonuMsgEvt;
    FThreadItemList: TThreadItemList;
    procedure SetResList(const Value: TResList);
    procedure AboneRes;
    procedure SetThreadItemList(const Value: TThreadItemList);
    procedure AboneThread;
  public
    { Public 錾 }
    property  ResList: TResList   read  FResList  write SetResList;
    property  ThreadItemList: TThreadItemList read  FThreadItemList write SetThreadItemList; 
    property  OnAboned: TZonuMsgEvt read  FAbonedEvt  write FAbonedEvt;
  end;

var
  AboneDialog: TAboneDialog;

implementation

{$R *.dfm}

uses
  MonaUtils, ZonuConf, Hzbconst, Hzbfunc;

procedure TAboneDialog.FormCreate(Sender: TObject);
begin
  Timer1.Enabled  :=  True;
end;

procedure TAboneDialog.SetResList(const Value: TResList);
var
  Item : TListItem;
  i : integer;
  S : string;
begin
  PageControl1.ActivePage :=  TabSheet1;

  ComboBox2.ItemIndex := ZonuConfig.QueryAboneHandleIndex;
  ComboBox4.ItemIndex := ZonuConfig.QueryAboneMailIndex;
  if (ComboBox2.ItemIndex < 0)  then  ComboBox2.ItemIndex := 0;
  if (ComboBox4.ItemIndex < 0)  then  ComboBox4.ItemIndex := 0;

  FResList := Value;
  //5 begin  tɒǉꂿႤ̂ŋtǉĂ݂
  //for i :=  0 to  FResList.Count - 1  do  begin
  for i :=  FResList.Count - 1  downto  0  do  begin
  //5 end
    if  (not FResList[i].IsAboned)  then  begin //5
      Item  :=  ListView1.Items.Add;
      //4  begin
      //Item.Caption  :=  IntToStr(i + 1);
      Item.Caption    :=  '@';
      Item.SubItems.Add(FormatFloat('0000', i + 1));
      //4  end
      s :=  TrimTag(FResList.Items[i].Name);
      Item.SubItems.Add(s);
      //4  begin
      //if  (Length(Trim(FResList.Items[i].Mail)) > 7)  then  begin
      //  //mailto:
      //  Item.SubItems.Add(Copy(FResList.Items[i].Mail,8,Length(FResList.Items[i].Mail)));
      //end else begin
      //  Item.SubItems.Add('');
      //end;
      Item.SubItems.Add(FResList.Items[i].Mail);
      //4  end
      Item.SubItems.Add(FResList.Items[i].ID);
      Item.SubItems.Add(TrimTag(FResList.Items[i].Body));
      Item.Data :=  FResList.Items[i];
      if  (ComboBox1.Items.IndexOf(s) < 0) and
          (Trim(S) <> '') then
      begin
        ComboBox1.Items.Add(S);
      end;
      if  (ComboBox5.Items.IndexOf(FResList.Items[i].ID) < 0) and
          (FResList.Items[i].ID <> '')  then
      begin
        ComboBox5.Items.Add(FResList.Items[i].ID);
      end;
      if  (Length(Trim(FResList.Items[i].Mail)) > 7)  then  begin
        S :=  AnsiLowerCase(Copy(FResList.Items[i].Mail,8,Length(FResList.Items[i].Mail)));
        if  (ComboBox3.Items.IndexOf(S) < 0)  and
            (Trim(S) <> '') then
        begin
          ComboBox3.Items.Add(S);
        end;
      end;
    end;  //5
  end;
  ListView1.Selected  :=  ListView1.Items[ListView1.Items.Count - 1];
end;

procedure TAboneDialog.BitBtn4Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    //7 begin
    //if  ((ComboBox2.ItemIndex = 0) and (ListView1.Items[i].SubItems[1] = ComboBox1.Text)) or
    //    ((ComboBox2.ItemIndex = 1) and (AnsiPos(ComboBox1.Text, ListView1.Items[i].SubItems[1]) > 0))
    if  ((ComboBox2.ItemIndex = 0) and (SameText(ListView1.Items[i].SubItems[1],ComboBox1.Text))) or
        ((ComboBox2.ItemIndex = 1) and (HzbFind(ComboBox1.Text, ListView1.Items[i].SubItems[1]) > 0))
    //7 end
    then begin
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
end;

procedure TAboneDialog.BitBtn5Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    //7 begin
    //if  ((ComboBox4.ItemIndex = 0) and (ListView1.Items[i].SubItems[2] = ComboBox3.Text)) or
    //    ((ComboBox4.ItemIndex = 1) and (AnsiPos(ComboBox3.Text, ListView1.Items[i].SubItems[2]) > 0))
    if  ((ComboBox4.ItemIndex = 0) and (SameText(ListView1.Items[i].SubItems[2], ComboBox3.Text))) or
        ((ComboBox4.ItemIndex = 1) and (HzbFind(ComboBox3.Text, ListView1.Items[i].SubItems[2]) > 0))
    //7 end
    then begin
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
end;

procedure TAboneDialog.Button2Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    //7 if  (ListView1.Items[i].SubItems[3] = ComboBox5.Text) then begin
    if  (SameText(ListView1.Items[i].SubItems[3], ComboBox5.Text)) then begin  //7
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
end;

procedure TAboneDialog.BitBtn3Click(Sender: TObject);
var
  i : integer;
  Res: TRes;  //5
begin
  //5 begin
  {
  for i :=  SpinEdit1.Value - 1 to  SpinEdit2.Value - 1 do  begin
    if  (i < ListView1.Items.Count)  then  begin
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
  }
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    Res :=  TRes(ListView1.Items[i].Data);
    if  (Res.No >= SpinEdit1.Value) and (Res.No <= SpinEdit2.Value) then  begin
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
  //5 end
end;

procedure TAboneDialog.Button1Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    //7 if  (AnsiPos(Edit1.Text, ListView1.Items[i].SubItems[4]) > 0)  then begin
    if  (HzbFind(Edit1.Text, ListView1.Items[i].SubItems[4]) > 0)  then  begin  //7
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
end;

procedure TAboneDialog.Button3Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (Length(WideString(ListView1.Items[i].SubItems[4])) <= SpinEdit3.Value) then begin
      ListView1.Items[i].Checked  :=  True;
    end;
  end;
end;

procedure TAboneDialog.Button6Click(Sender: TObject);
begin
  if  (PageControl1.ActivePage = TabSheet1) then  begin
    AboneRes;
  end else begin
    AboneThread;
  end;
  ModalResult :=  mrOk;
end;

procedure TAboneDialog.AboneRes;
var
  i : integer;
  n : integer;
  Res: TRes; //5
begin
  n :=  0;
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Checked)  then  begin
      //5 begin
      {
      if  (not FResList.Items[i].IsAboned)  then  begin
        FResList.Items[i].IsAboned  :=  True;
        if  (Assigned(FAbonedEvt))  then  begin
          FAbonedEvt(Self,
                     Format('  %d', [FResList.Items[i].No]));
          FAbonedEvt(Self,
                     Format('  %s : %s',
                            [TrimTag(FResList.Items[i].Name),
                             TrimTag(FResList.Items[i].Body)]));
        end;
        inc(n);
      end;
      }
      Res :=  TRes(ListView1.Items[i].Data);
      if  (not Res.IsAboned)  then  begin
        Res.IsAboned  :=  True;
        if  (Assigned(FAbonedEvt))  then  begin
          FAbonedEvt(Self,
                     Format('  %d', [Res.No]));
          FAbonedEvt(Self,
                     Format('  %s : %s',
                            [TrimTag(Res.Name),
                             TrimTag(Res.Body)]));
        end;
        inc(n);
      end;
      //5 end
    end;
  end;
  if  (Assigned(FAbonedEvt))  then  begin
    FAbonedEvt(Self,
               Format('%d ̃X܂B', [n]));
  end;
  ZonuConfig.QueryAboneHandleIndex  :=  ComboBox2.ItemIndex;
  ZonuConfig.QueryAboneMailIndex    :=  ComboBox4.ItemIndex;
end;

procedure TAboneDialog.Button7Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TAboneDialog.SetThreadItemList(const Value: TThreadItemList);
var
  Item : TListItem;
  i : integer;
begin
  PageControl1.ActivePage :=  TabSheet2;

  FThreadItemList := Value;
  for i :=  0 to  FThreadItemList.Count - 1  do  begin
    if  (not FThreadItemList[i].IsAboned) then  begin     //5
      Item     :=  ListView2.Items.Add;
      //4 begin
      //Item.Caption :=  Format('%.4d', [ThreadItemList[i].No]) + ' ' +
      //                 ThreadItemList[i].Title;
      Item.Caption  :=  '';
      Item.SubItems.Add(  Format('%.4d', [ThreadItemList[i].No]) + ' ' +
                          ThreadItemList[i].Title);
      //4 end
      Item.SubItems.Add(IntToStr(ThreadItemList[i].AgeCount));
      if  (ThreadItemList[i].ReadCount > 0)  then  begin
        Item.SubItems.Add(IntToStr(ThreadItemList[i].ReadCount));
      end else begin
        Item.SubItems.Add('@');
      end;
      Item.SubItems.Add(ThreadItemList[i].DatFileName);
      Item.Data  :=  ThreadItemList[i];
      //ComboBox1.Items.Add(Trim(ThreadItemList[i].Title));
      ComboBox7.Items.Add(ThreadItemList[i].DatNo);
    end;
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_QUERYABONE_THREAD)) then  begin
    ComboBox6.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_QUERYABONE_THREAD);
  end;
end;

procedure TAboneDialog.Button4Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView2.Items.Count - 1 do  begin
    //7 if  (AnsiPos(ComboBox6.Text, TThreadItem(ListView2.Items[i].Data).Title) > 0) then
    if  (HzbFind(ComboBox6.Text, TThreadItem(ListView2.Items[i].Data).Title) > 0) then  //7
    begin
      ListView2.Items[i].Checked  :=  True;
    end;
  end;
  if  (ComboBox6.Items.IndexOf(ComboBox6.Text) < 0) then  begin
    ComboBox6.Items.Insert(0, ComboBox6.Text);
  end else begin
    ComboBox6.Items.Move(ComboBox6.Items.IndexOf(ComboBox6.Text), 0);
  end;
end;

procedure TAboneDialog.Button5Click(Sender: TObject);
var
  i : integer;
begin
  for i :=  0 to  ListView2.Items.Count - 1 do  begin
    if  (TThreadItem(ListView2.Items[i].Data).DatNo = ComboBox7.Text) then
    begin
      ListView2.Items[i].Checked  :=  True;
      Break;
    end;
  end;
end;

procedure TAboneDialog.AboneThread;
var
  i : integer;
  n : integer;
  ThreadItem: TThreadItem; //5
begin
  n :=  0;
  for i :=  ListView2.Items.Count - 1 downto  0 do  begin
    if  (ListView2.Items[i].Checked)  then  begin
      //5 begin
      {
      if  (not FThreadItemList.Items[i].IsAboned)  then  begin
        FThreadItemList.Items[i].LoadConfig;
        FThreadItemList.Items[i].IsAboned  :=  True;
        FThreadItemList.Items[i].SaveConfig;
        if  (Assigned(FAbonedEvt))  then  begin
          FAbonedEvt(Self,
                     Format('  %d', [i + 1]));
          FAbonedEvt(Self,
                     Format('  %s : %s',
                            [TrimTag(FThreadItemList.Items[i].Title),
                             TrimTag(FThreadItemList.Items[i].DatNo)]));
        end;
        FThreadItemList.Delete(i);
        inc(n);
      end;
      }
      ThreadItem  :=  TThreadItem(ListView2.Items[i].Data);
      if  (not ThreadItem.IsAboned)  then  begin
        ThreadItem.LoadConfig;
        ThreadItem.IsAboned  :=  True;
        ThreadItem.SaveConfig;
        if  (Assigned(FAbonedEvt))  then  begin
          FAbonedEvt(Self,
                     Format('  %d', [ThreadItem.No]));
          FAbonedEvt(Self,
                     Format('  %s : %s',
                            [TrimTag(ThreadItem.Title),
                             TrimTag(ThreadItem.DatNo)]));
        end;
        FThreadItemList.Delete(i);
        inc(n);
      end;
      //5 end
    end;
  end;
  if  (Assigned(FAbonedEvt))  then  begin
    FAbonedEvt(Self,
               Format('%d ̃Xbh܂B', [n]));
  end;
  ComboBox6.Items.SaveToFile(ZonuConfig.UsersPath + FILE_QUERYABONE_THREAD);
end;



procedure TAboneDialog.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled :=  False;
  if  (PageControl1.ActivePage = TabSheet1) then  begin
    ComboBox1.SetFocus;
  end else begin
    ComboBox6.SetFocus;
  end;
end;

//4
procedure TAboneDialog.ListView1ItemChecked(Sender: TObject;
  ItemIndex: Integer; Checked: Boolean);
begin
  if  (Checked) then  begin
    TdfsExtListView(Sender).Items[ItemIndex].Caption  :=  '';
  end else begin
    TdfsExtListView(Sender).Items[ItemIndex].Caption  :=  ' ';
  end;
end;

//7
procedure TAboneDialog.AllCheckClick(Sender: TObject);
var
  n: integer;
  ListView: TdfsExtListView;
begin
  if  (PageControl1.ActivePage = TabSheet1) then  begin
    ListView  :=  ListView1;
  end else begin
    ListView  :=  ListView2;
  end;
  for n :=  0 to  ListView.Items.Count - 1  do  begin
    ListView.Items[n].Checked :=  (Sender = AllCheck);
  end;
end;

end.
