{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Priority Dialog Unit                                              }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Prordlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls, Dlghead;

type
  TPriorityDialog = class(TForm)
    TrackBar1: TTrackBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    HeaderFrame1: THeaderFrame;
    procedure TrackBar1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    function GetValue: integer;
    procedure SetValue(const Value: integer);
    { Private 錾 }
  public
    { Public 錾 }
    property  Value: integer  read  GetValue  write SetValue;
  end;

var
  PriorityDialog: TPriorityDialog;

implementation

{$R *.dfm}

function TPriorityDialog.GetValue: integer;
begin
  Result  :=  TrackBar1.Position;
end;

procedure TPriorityDialog.SetValue(const Value: integer);
begin
  if  (Value < TrackBar1.Min) then  begin
    TrackBar1.Min :=  Value;
  end;
  if  (Value > TrackBar1.Max) then  begin
    TrackBar1.Max :=  Value;
  end;
  TrackBar1.Position  :=  Value;
end;

procedure TPriorityDialog.TrackBar1Change(Sender: TObject);
begin
  Label2.Caption  :=  IntToStr(TrackBar1.Position);
end;

procedure TPriorityDialog.BitBtn1Click(Sender: TObject);
begin
  ModalResult :=  mrOk;
end;

procedure TPriorityDialog.BitBtn2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

end.
